Subject: [bug#47768] ocaml - how can we get more recent version of core-kernel and common ppx'es

From: "[email-masked]" <[email-masked]>
Date: Tue, 18 May 2021 20:58:37 +0000

Great, this is exactly what I was hoping to find! I had of course forgotten to search the debbugs and in the devel mailing list there were only really old threads about the 4.07 stuff. 

Thanks for your work here, I will test your patches and let you know :)

Sent from my iPhone

> On 18 May 2021, at 22:38, pukkamustard <[email-masked]> wrote:
> 
> Hi Erik,
> 
> There has been some work towards updating the OCaml packages in Guix (see https://issues.guix.gnu.org/47768).
> 
> A lot of packages have been updated so that there is a now an updated ocaml-X package for a previously existing ocaml4.07-X package. This includes a lot of ppx'es. However not everything has been updated yet and there are still a few packages missing to be able to update ocaml-core-kernel. But maybe you could use the #47768 as a basis and update some packages towards ocaml-core-kernel?
> 
> Help is also required in reviewing the patches. The series has become quite large and hard to review (42 patches). If you could try them out that would be great.
> 
> -pukkamustard
> 
> 
> Erik <[email-masked]> writes:
> 
>> Hi, I have a project that requires a more recent core-kernel and some of the
>> ppx'es (such as ppx_fields_conv).
>> 
>> Being very new to guix I've managed to add/update packages for python and ruby
>> stuff, but this ocaml.scm file is quite different. There's a lot going on which
>> I'm guessing is related to complexities arising from the whole ppx transition
>> that happened in the ocaml ecosystem a few years ago, or perhaps just to the
>> somewhat unsynchronized way libraries move to new versions of the compiler and
>> libs (just speculating here).
>> 
>> Anyway afaict (with my limited guix-fu) I would either need to duplicate a whole
>> lot of packages or somehow reorganize things to share definitions where it makes
>> sense. Both those options would require some coordination with the people who
>> made the ocaml.scm infrastructure first, because clearly there are projects out
>> there that need the current set of packages to work like they do now and I don't
>> want to just post a huge patch that surprises these people.
>> 
>> Can we get a thread going somewhere on adding a recent version of
>> ocaml-core-kernel (for the 4.11.1 ocaml package, possibly bumping that to 4.11.2 in the process)?
>> 
>> Best regards,
>> Erik Lovlie
>